#ifndef MULTITHREAD_H
#define MULTITHREAD_H

#include <QMainWindow>
 #include <QThread>
#include <QObject>
#include <QMutex>
#include <QWaitCondition>
//#include<mainwindow.h>

class MultiThread : public QObject
{
    Q_OBJECT
public:

     MultiThread(QObject *parent = 0);
     void requestThread();
       void abort();
    void resume();


private:

    bool _abort;
    bool _working;
    QMutex mutex;
    QWaitCondition pauseContd;
     //MainWindow *mainwindow;


signals:
    void setChange();
    void multithreadRequested();

    void valueChanged(const QString &value);

    void finished();
    void resumed();

public slots:

    void doMultiThraed();

};




#endif // MULTITHREAD_H
