#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "Multithread.h"
#include <QThread>
namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
        int m_width;
        int m_Height;
        int m_NoOfRows;
        int m_NoOfCols;
        int m_XOffset; //Offset from which drawing start
        int m_YOffset;
        int m_ZOffset;
        qreal x;
        qreal y;
        qreal amplitude;
        qreal Time;
        qreal timePeriod;
        qreal x1;
        qreal y1;
        int jcounter;
        int flagncount;

    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);
    void paintEvent(QPaintEvent *);
       void Initialize();

private:
    Ui::MainWindow *ui;
    QThread *thread;
        MultiThread *multithread;

private slots:
        void on_actionPAUSE_activated();
        void on_actionSTART_activated();
        void setValue();
    void on_pushButton_2_clicked();
    void on_pushButton_clicked();
};

#endif // MAINWINDOW_H
